"""The interface for an OntoUML object exposed on a view as exported by Visual
Paradigm"""


from dataclasses import dataclass
from typing import Any

from src.onto_uml.onto_uml_model_element import OntoUmlModelElement
from src.onto_uml.views.shapes.shape import Shape


@dataclass
class ObjectViewDefaultsBase:
    """
    Interface for the OntoUML object fields with default values. Base for `ObjectView`
    """

    _parent: Any = None


@dataclass
class ObjectViewBase:
    """
    Interface for the OntoUML object fields
    """

    identifier: str
    """The id generated by Visual Paradigm for this class view"""
    model_element: OntoUmlModelElement
    """The model element represented by this class view"""
    shape: Shape
    """The shape used to represent the object"""


@dataclass
class ObjectView(ObjectViewDefaultsBase, ObjectViewBase):
    """Interface for an OntoUML object exposed on a view, as exported by Visual
    Paradigm"""
